#include "game.h"

SceneManager* Manager = SceneManager::GetInstance(); 
Gamestate gamestate;


// 게임 초기화
void Game::Init(int width, int height, std::string title) 
{
    SetWindowSize(width, height);
    SetWindowTitle(title.c_str());


    gamestate = Gamestate::game;  


}

Game::~Game()
{

} 

void Game::Tick()
{
    BeginDrawing();
    Update();
    Draw();
    EndDrawing(); 
}

void Game::Update()
{
    // Update

    // 각 게임스테이트마다 상황 설정
    switch (gamestate)
    {   

        case Gamestate::pause :    // 정지로직  
             if (IsButtonPressed("Jump"))
            {
                gamestate = Gamestate::game;    // 게임으로 돌아가기 
            }

            if (gamestate == Gamestate::pause && IsButtonPressed("ESCAPE")) Manager->gameExit = true;   // 정지상태일때, ESC 누르면 종료

            break;

        case Gamestate::game :  // 게임로직

            // if (IsButtonESCPressed()) 
            if (IsButtonPressed("ESCAPE"))
            {
                gamestate = Gamestate::pause;  // 게임정지로 바꾸기 
                PauseMusicStream(Manager->music);
            }

            break; 
        
        default: 
            break;
    }
}


void Game::Draw()
{ 
    // Draw
    switch(gamestate)
    {
        case Gamestate::pause :   // 정지화면 그리기 

            // 정지화면 
            DrawRectangle(GetScreenWidth() / 2 - 180, GetScreenHeight() / 2 - 60, 360, 120, DARKBROWN);
            DrawText("Press Arrow Up  if you continue", GetScreenWidth() / 2 - 160, GetScreenHeight() / 2 -20, 20, MAGENTA);
            DrawText("Press ESC to Exit Game", GetScreenWidth() / 2 - 160, GetScreenHeight() / 2 + 10, 20, MAGENTA);
            break;

        case Gamestate::game:  // 게임화면 그리기 

            // 게임 UI  
            if (IsGamepadAvailable(gamepad)) 
            {
                DrawText("Pause : Press ESC", GetScreenWidth() - 200, 20, 20, DARKGRAY);


            }else
            {
                DrawText("Pause : Select button", GetScreenWidth() - 200, 20, 20, DARKGRAY);

            };
            break;
    }
}
